%
clear;
clc;

% Anfangswert
t0 = 0;
y0 = 5;

% Rechte Seite
f = @(t,y) -2*y;

% Vektor mit Anzahl der verwendeten Schritte
N = 2.^(6:10);

% Ende zeit
T = 5;

% Bestimme eine Approximation mit AB2 mit N(k) Schritten
error_AB2 = zeros(1,length(N));
for k = 1:length(N)
  [t,yN_approx] = AB2(f,t0,T,y0,N(k));
  
  % Exakte Loesung
  yN_exakt = y0*exp(-2.*t);
  
  % compute error
  error_AB2(k) = abs(yN_approx(end) - yN_exakt(end));
end

loglog (N, error_AB2,'*-');
xlim([4e+1,2e+3]);
ylim([1e-8, 1e-4]);
str = sprintf('2-step Adams-Bashforth');
title(str);
grid on;

p = polyfit(log(N), log(error_AB2), 1);
convg_order = -p(1);
display(convg_order);
